return { style = 'dialog',
  { style = 'dialogHead', text = 'Personal Settings' },
  { style = 'dialogBody', padding = 24, flow = 'x',
    {
      { type = 'check', value = false, id = 'music', text = "Randomize music", minheight = 32, width = 170},
      { type = 'label', text = 'Type of randomization' },
      { type = 'radio', group = 'flavor', text = 'Shuffle', id = 'shuffle', minheight = 27, status = "Remap every song to a new song. For example, all instances of Mischievous Robot become Pulse. Songs may remap to themselves." },
      { type = 'radio', group = 'flavor', text = 'Random', id = 'random', minheight = 27, status = "Remap every cue to a new song. For example, entering the Egg Corridor by any means plays Meltdown 2." },
      { type = 'radio', group = 'flavor', text = 'Chaos', id = 'chaos', minheight = 27, status = "Remap every <CMU to a new song. For example, teleporting to the Egg Corridor plays Charge, but entering Egg Corridor from Cthulhu's Abode plays Run!" },
      { type = 'label', text = 'Enabled music' },
      --[[ individual toggles is a lot of work actually
      { type = 'panel', id = 'musicToggles', scroll = true, 
        { type = 'check', id = 'mischievousRobot', value = true, text = 'Mischievous Robot', minheight = 27},
        { type = 'check', id = 'safety', value = true, text = 'Safety', minheight = 27},
        { type = 'check', id = 'gravity', value = true, text = 'Gravity', minheight = 27},
        { type = 'check', id = 'onToGrasstown', value = true, text = 'On to Grasstown', minheight = 27},
        { type = 'check', id = 'meltdown', value = true, text = 'Meltdown 2', minheight = 27},
        { type = 'check', id = 'eyesOfFlame', value = true, text = 'Eyes of Flame', minheight = 27},
        { type = 'check', id = 'gestation', value = true, text = 'Gestation', minheight = 27},
        { type = 'check', id = 'mimigaTown', value = true, text = 'Mimiga Town', minheight = 27},
        { type = 'check', id = 'balrogsTheme', value = true, text = "Balrog's Theme", minheight = 27},
        { type = 'check', id = 'cemetary', value = true, text = 'Cemetary', minheight = 27},
        { type = 'check', id = 'plant', value = true, text = 'Plant', minheight = 27},
        { type = 'check', id = 'pulse', value = true, text = 'Pulse', minheight = 27},
        { type = 'check', id = 'tyrant', value = true, text = 'Tyrant', minheight = 27},
        { type = 'check', id = 'run', value = true, text = 'Run!', minheight = 27},
        { type = 'check', id = 'jenka1', value = true, text = 'Jenka 1', minheight = 27},
        { type = 'check', id = 'labyrinthFight', value = true, text = 'Labyrinth Fight', minheight = 27},
        { type = 'check', id = 'access', value = true, text = 'Access', minheight = 27},
        { type = 'check', id = 'oppression', value = true, text = 'Oppression', minheight = 27},
        { type = 'check', id = 'geothermal', value = true, text = 'Geothermal', minheight = 27},
        { type = 'check', id = 'caveStory', value = true, text = 'Cave Story', minheight = 27},
        { type = 'check', id = 'moonsong', value = true, text = 'Moonsong', minheight = 27},
      }
      ]]
      { type = 'check', id = 'cavestory', value = true, text = 'Enable Cave Story music', minheight = 27 },
      { type = 'check', id = 'beta', value = false, text = 'Enable beta music', minheight = 27, status = "Only compatible with the included Doukutsu.exe - no other platforms." },
      { type = 'check', id = 'kero', value = false, text = 'Enable Kero Blaster music', minheight = 27, status = "Only compatible with the included Doukutsu.exe - no other platforms." },
    },
    { type = 'sash' },
    {
      width = 275,
      { type = 'label', text = 'Player Sprite', minheight = 32 },
      { type = 'stepper', id = 'mychar', align = 'middle left', height = 48, width = 200,
        { text = "  Quote", value = "assets/myChar/Quote.bmp", icon = "assets/icon/Quote.png" },
        { text = "  Curly", value = "assets/myChar/Curly.bmp", icon = "assets/icon/Curly.png" },
        { text = "  Sue", value = "assets/myChar/Sue.bmp", icon = "assets/icon/Sue.png" },
        { text = "  Toroko", value = "assets/myChar/Toroko.bmp", icon = "assets/icon/Toroko.png" },
        { text = "  King", value = "assets/myChar/King.bmp", icon = "assets/icon/King.png" },
        { text = "  Chaco", value = "assets/myChar/Chaco.bmp", icon = "assets/icon/Chaco.png" },
        { text = "  Kanpachi", value = "assets/myChar/Kanpachi.bmp", icon = "assets/icon/Kanpachi.png" },
        { text = "  Misery", value = "assets/myChar/Misery.bmp", icon = "assets/icon/Misery.png" },
        { text = "  Frog", value = "assets/myChar/Frog.bmp", icon = "assets/icon/Frog.png" },
        { text = "  Random", value = "random", icon = "assets/icon/Random.png", status = "Choose a random sprite each time you randomize." },
        { text = "  Custom", value = false, icon = "assets/icon/Custom.png", status = "Use your own mychar.bmp! Place it in the main data folder." },
      },
      { type = 'sash' },
      { type = 'status', wrap = true, height = false, },
    },
  },
  { style = 'dialogFoot',
    {},
    { style = 'dialogButton', id = 'close', text = 'Close' }
  }
}